#include <iostream>
#include <string>
#include <vector>
using namespace std ;
using ll = long long ;
int h, w ;
string b ;
/*
 *   State:
 *      0: virgin
 *      cookie: on this tree
 */
vector<int> state ;
vector<int> colv ;
vector<int> dd ;
const int INF = 1000000000 ;
int cookie = 1 ;
int flipped ;
int garg ;
int looped ;
int blocked[2] ;
void dfs(int i, int prev, int col) {
   int c = b[i] ;
   if ((c == 'H' || c == 'V') && state[i] == cookie &&
       colv[i] != ((col ^ prev) & 1))
      looped = INF ;
   if (state[i] == cookie)
      return ;
   state[i] = cookie ;
   int nd = prev ;
   switch(c) {
case '#':
      blocked[col] = INF ;
      break ;
case 'H':
case 'V':
      garg++ ;
      colv[i] = (col ^ prev) & 1 ;
      if (1==((col ^ prev ^ (c == 'H')) & 1))
         flipped++ ;
      for (int d=0; d<4; d++)
         if (d != prev)
            dfs(i+dd[d], d, (col ^ prev ^ d) & 1) ;
      break ;
case '.':
      dfs(i+dd[prev], prev, col) ;
      break ;
case '/':
      nd = prev ^ 1 ;
      dfs(i+dd[nd], nd, col) ;
      break ;
case '\\':
      nd = prev ^ 3 ;
      dfs(i+dd[nd], nd, col) ;
      break ;
case '|':
case '-':
      break ;
default:
      cout << "Bad edge " << c << endl ;
   }
}
int scan(int i) {
   if (state[i] != 0)
      return 0 ;
   cookie++ ;
   looped = 0 ;
   flipped = 0 ;
   garg = 0 ;
   blocked[0] = blocked[1] = 0 ;
   dfs(i, 15, 1) ;
   return max(looped, min(max(blocked[0], flipped), max(blocked[1], garg-flipped))) ;
}
int main() {
   cin >> h >> w ;
   for (int i=0; i<=w; i++)
      b.push_back('-') ;
   for (int i=0; i<h; i++) {
      b.push_back('|') ;
      string s ;
      cin >> s ;
      b += s ;
   }
   b.push_back('|') ;
   for (int i=0; i<=w; i++)
      b.push_back('-') ;
   dd = { -w-1, 1, w+1, -1 } ;
   state = vector<int>(b.size()) ;
   colv = vector<int>(b.size()) ;
   ll r = 0 ;
   for (int i=0; i<(int)b.size(); i++)
      if (b[i] == 'H' || b[i] == 'V')
         r += scan(i) ;
   if (r >= INF)
      cout << -1 << endl ;
   else
      cout << r << endl ;
}
